import React, { PureComponent } from "react";
import { connect } from "dva";
import AlloyFinger from "alloyfinger/react/AlloyFinger";
import { message } from "antd";

let text_color = "";
class EditMain extends PureComponent {
  state = {
    pageX: 0,
    pageY: 0,
  };
  async uploadPhoto(e, name, item, _k) {
    const { dispatch,editModel:{check,allMaterialByGroup} } = this.props;
    if (e.target.files.length === 0) return;
    let file = e.target.files[0];
    let index = file.name.lastIndexOf(".");
    let ext = file.name.substr(index + 1).toLowerCase();
    if (ext !== "jpg" && ext !== "png" && ext !== "jpeg") {
      message.warning("请选择图片文件");
      return;
    }

    const imgURL = window.URL.createObjectURL(file);
    let reader = new FileReader();
    reader.readAsDataURL(file);
    reader.onload = function(e) {
      let image = new Image();
      image.src = e.target.result;
      image.onload = function() {
        let w = this.width;
        let h = this.height;
        // groups[check].allMaterial
      let allGroup = allMaterialByGroup[check][_k];
      let recordX 
      let recordY
      let initialScale 
      let obj={}
      // if (feg === 0) {
        if (h > allGroup["originSize"][1]+200 && w > allGroup["originSize"][0]+200) {
          initialScale = allGroup["originSize"][0] / w;
          recordX = -w *(1-initialScale)/2;
          recordY = -h *(1-initialScale)/2;
          obj = {
            ...item,
            originSize: [w, h],
            anchor: [w / 2, h / 2],
            position:[recordX+allGroup.position[0],recordY+allGroup.position[1]],
            distScale:[initialScale,initialScale],
            recordSacle:initialScale,
            initialScale:initialScale,
            initialPosition:[recordX+allGroup.position[0],recordY+allGroup.position[1]]
          };
        }else{
          obj = {
            ...item,
            originSize: [w, h],
            anchor: [w / 2, h / 2],
            position:[allGroup.position[0],allGroup.position[1]],
            distScale:[1,1],
            recordSacle:initialScale
          };
        }
        // obj = {
        //   ...item,
        //   originSize: [w, h],
        //   anchor: [w / 2, h / 2],
        // };
        
        dispatch({
          type: "edit/handleTextChangeItem",
          payload: {
            obj: obj,
            index: _k,
          },
        });
        dispatch({
          type: "edit/uploadPhoto",
          payload: {
            [name]: imgURL,
          },
        });
      };
    };
  }

  handleImageMaterialClick(e, item) {
    console.log();
    let upload = e.target.parentNode.nextSibling;
    let ev = document.createEvent("MouseEvents");
    ev.initEvent("click", true, true);
    upload.dispatchEvent(ev);
    // const { dispatch } = this.props;
    // dispatch({
    //   type: "edit/changecolorflag",
    //   payload: {
    //     color_flag: false,
    //   },
    // });
  }

  onPressMove = (evt, index) => {
    const {
      editModel: { groups, check, ratio ,allMaterialByGroup},
      dispatch,
    } = this.props;
    let starX = allMaterialByGroup[check][index].position[0];
    let starY = allMaterialByGroup[check][index].position[1];
    let x = groups[check].allMaterial[index].position[0];
    let y = groups[check].allMaterial[index].position[1];
    let deltaX = evt.deltaX / ratio;
    let deltaY = evt.deltaY / ratio;

    let distPosition = [0, 0];
    if (groups[check].allMaterial[index]["distPosition"]) {
      distPosition = groups[check].allMaterial[index]["distPosition"];
      // distPosition[0] = groups[check].allMaterial[index]["distPosition"][0] + deltaX;
      // distPosition[1] = groups[check].allMaterial[index]["distPosition"][1] + deltaY;
      if(groups[check].allMaterial[index].initialScale){
        distPosition[0] = groups[check].allMaterial[index].position[0] + deltaX-starX;
        distPosition[1] = groups[check].allMaterial[index].position[1] + deltaY-starY;
      }else{
        distPosition[0] = groups[check].allMaterial[index]["distPosition"][0] + deltaX;
        distPosition[1] = groups[check].allMaterial[index]["distPosition"][1] + deltaY;
      }
    }
    let obj = {
      ...groups[check].allMaterial[index],
      position: [x + deltaX, y + deltaY],
      distPosition,
    };
    dispatch({
      type: "edit/onPressMove",
      payload: {
        index: index,
        obj: obj,
        color_flag: false,
      },
    });
  };

  onRotate = (evt, index) => {
    const {
      editModel: { groups, check },
      dispatch,
    } = this.props;
    let r = groups[check].allMaterial[index].rotate;
    let s = r + evt.angle;

    let distRotate = 0;
    if (!groups[check].allMaterial[index]["distRotate"]) {
      distRotate = 0;
    }

    distRotate = s;

    let obj = {
      ...groups[check].allMaterial[index],
      rotate: s,
      distRotate: distRotate,
    };
    dispatch({
      type: "edit/onPressMove",
      payload: {
        index: index,
        obj: obj,
        color_flag: false,
      },
    });
    // cc = scaldate;
  };

  onPinch = (evt, index) => {
    const {
      editModel: { groups, check },
      dispatch,
    } = this.props;
    // let currentScale = groups[check].allMaterial[index].scale[1];
    let recordSacle = 1;
    if (groups[check].allMaterial[index].recordSacle) {
      recordSacle = groups[check].allMaterial[index].recordSacle;
    }
    // let originalScale=allMaterialByGroup[check][index].scale[1]
    // message.info(originalScale)
    let scaldate = evt.scale * recordSacle;
    let distScale = [scaldate, scaldate];
    if (!groups[check].allMaterial[index]["distScale"]) {
      distScale = [1, 1];
    } else {
    }
    distScale[0] = scaldate;
    distScale[1] = scaldate;

    let obj = {
      ...groups[check].allMaterial[index],
      scale: distScale,
      distScale: distScale,
    };
    dispatch({
      type: "edit/onPressMove",
      payload: {
        index: index,
        obj: obj,
        color_flag: false,
      },
    });
  };

  onMultipointEnd = (evt, index) => {
    const {
      editModel: { groups, check },
      dispatch,
    } = this.props;
    let obj = {
      ...groups[check].allMaterial[index],
      recordSacle: groups[check].allMaterial[index].scale[1],
    };
    dispatch({
      type: "edit/onPressMove",
      payload: {
        index: index,
        obj: obj,
        color_flag: false,
      },
    });
  };

  handleTextFocus = (item, e, k) => {
    text_color = e.target.style.color;
    e.target.style.background = "rgba(243, 7, 8,0.3)";
    const {
      dispatch,
      editModel: { txtNum, color_flag },
    } = this.props;
    let items = {
      textColor: item.fontSetting.textColor,
      maxLength: item.fontSetting.maxLength,
      strokeColor: item.fontSetting.strokeColor,
      strokeWidth: item.fontSetting.strokeWidth,
      defaultText: item.fontSetting.defaultText,
      textAlign: item.fontSetting.textAlign,
    };
    if (color_flag) {
      dispatch({
        type: "edit/changecolorflag",
        payload: {
          color_flag: false,
        },
      });
    } else {
      dispatch({
        type: "edit/recadTextModal",
        payload: {
          recadTextModalItem: item,
          fontcolorchange: items,
          reacdTextIndex: k,
          txtNum: txtNum + 1,
          color_flag: true,
        },
      });
    }
    e.target.blur();
  };

  handleTextBlur = (item, e, k) => {
    const { dispatch } = this.props;
    e.target.style.color = text_color;
    e.target.style.background = "rgba(255, 255, 255,0)";
    let obj = { ...item };
    obj.fontSetting.defaultText = e.target.value;
    dispatch({
      type: "edit/handleTextChangeItem",
      payload: {
        index: k,
        obj: obj,
      },
    });
    // let arr = this.state.allMaterial.splice(k, 1, obj);
    // this.props.change(this.state.allMaterial);
  };

  handleTextChange = (e, item) => {
    // console.log(item);
    // console.log(e.target.value);
  };

  closeflag = e => {
    e.stopPropagation();
  };

  renderMaterial = () => {
    const {
      editModel: { groups, check, assetList, ratio, allMaterialByGroup },
    } = this.props;
    return groups[check].allMaterial.map((item, index) => {
      let uiResult = null;
      let defaultZIndex = 2;
      let key = item.assetName;
      let s = item.scale[0];
      let x = item.position[0];
      let y = item.position[1];
      let aX = item.anchor[0];
      let aY = item.anchor[1];
      let w = item["originSize"][0];
      let h = item["originSize"][1];
      let r = item.rotate;

      let starX = allMaterialByGroup[check][index].position[0];
      let starY = allMaterialByGroup[check][index].position[1];
      let allGroup = allMaterialByGroup[check][index];
      let initialScale = 1;
      let currentScale = 1;
      let currentRotate = 0;
      let recordX = x - starX;
      let recordY = y - starY;
      if (item.distScale !== undefined) {
        currentScale = item.distScale[0];
      }
      if (item.distRotate !== undefined) {
        currentRotate = item.distRotate;
      }

      const innerStyle = {
          position: "absolute",
          width: `${w}px`,
          height: `${h}px`,
          left: 0,
          top: 0,
          transform: `translate(${recordX}px, ${recordY}px) rotate(${currentRotate}deg) scale(${currentScale *
            initialScale})`,
        },
        containerStyle = {
          position: "absolute",
          zIndex: item.zIndex + defaultZIndex,
          left: 0,
          top: 0,
          transform: `scale(${ratio})`,
          opacity: `${item.transparence}`,

          transformOrigin: "0px 0px 0px",
        },
        textsty = {
          position: "absolute",
          left: `${-aX}px`,
          top: `${-aY}px`,
          width: `${w}px`,
          height: `${h}px`,
          transformOrigin: `${aX}px ${aY}px`,
          transform: `translate(${x}px, ${y}px) rotate(${r}deg) scale(${s})`,
        };
      // let allGroup = allMaterialByGroup[check][index];
      const innerStylebor = {
        position: "absolute",
        left: `${-allGroup.anchor[0]}px`,
        top: `${-allGroup.anchor[1]}px`,
        width: `${allGroup["originSize"][0] - 4}px`,
        height: `${allGroup["originSize"][1] - 4}px`,
        transformOrigin: `${allGroup.anchor[0]}px ${allGroup.anchor[1]}px`,
        transform: `translate(${allGroup.position[0]}px, ${allGroup.position[1]}px) rotate(${allGroup.rotate}deg) scale(${allGroup.scale[0]})`,
        border: "4px dashed  red",
        overflow: "hidden",
        // pointerEvents: 'none'
      };
      let _k = index;
      switch (item.type) {
        case 1:
          uiResult = (
            <div style={containerStyle} key={key}>
              <div style={innerStylebor}>
                <AlloyFinger
                  onPressMove={evt => this.onPressMove(evt, _k)}
                  onRotate={evt => this.onRotate(evt, _k)}
                  onPinch={evt => this.onPinch(evt, _k)}
                  onMultipointEnd={evt => this.onMultipointEnd(evt, _k)}
                >
                  <img
                    className="innerStyle"
                    style={innerStyle}
                    src={assetList[key]}
                    onClick={e => this.handleImageMaterialClick(e, item)}
                    alt="asset"
                  />
                </AlloyFinger>
              </div>

              <input
                style={{ display: "none" }}
                type="file"
                accept="image/*"
                className="upload"
                name="photo"
                camera="true"
                onChange={e => this.uploadPhoto(e, item.assetName, item, _k)}
              />
            </div>
          );
          break;
        case 2:
        case 3:
          const {
              defaultText,
              fontSize,
              textAlign,
              textColor,
              maxLength,
              strokeWidth,
              strokeColor,
            } = item.fontSetting,
            textAligns = {
              0: "left",
              1: "right",
              2: "center",
            },
            textareaStyle = {
              ...textsty,
              textAlign: textAligns[textAlign],
              fontSize: `${fontSize}px`,
              color: textColor,
              WebkitTextStroke: `${strokeWidth}px ${strokeColor}`,
              background: "rgba(255,255,255,0)",
              border: "3px dotted red",
              lineHeight: "120%",
            };

          let newFontSize = fontSize;
          if (fontSize > 140) {
            newFontSize *= 0.7;
          } else if (fontSize > 130) {
            newFontSize *= 0.75;
          }

          if (newFontSize >= h) {
            newFontSize *= 0.75;
          }
          // if (item["key"] === "assetkey21") {
          //   console.log(textColor);
          //

          textareaStyle.fontSize = newFontSize;

          uiResult = (
            <div key={key} style={containerStyle}>
              <textarea
                ref={_k}
                style={textareaStyle}
                maxLength={maxLength}
                value={defaultText}
                onFocus={e => this.handleTextFocus(item, e, _k)}
                onBlur={e => this.handleTextBlur(item, e, _k)}
                onChange={e => this.handleTextChange(e, item, _k)}
                onClick={this.closeflag}
              />
            </div>
          );
          break;

        default:
          uiResult = null;
          break;
      }

      return uiResult;
    });
  };

  render() {
    return <div>{this.renderMaterial()}</div>;
  }
}
const stateToProps = state => ({
  editModel: state["edit"],
});

export default connect(stateToProps)(EditMain);
