import React, { PureComponent } from "react";
import { connect } from "dva";
import { Button ,Icon} from "antd";
import styles from "./index.less";
import AlloyFinger from "alloyfinger/react/AlloyFinger";
import router from "umi/router";

class VideoClip extends PureComponent {
  constructor(props) {
    super(props);
    this.contentRef = React.createRef();
    this.cuttingRef = React.createRef();

    this.state = {
      needX: 0,
      arrOption: [],
      videoRef: null,
      totalTime: 0,
      containerWidth: 300,
      unit: 10,
      muted:true
    };

    this.disX = 0;
    this.X = 0;
    this.startTime = 0;
    this.endTime = 0;
    this.shengyi=this.shengyi.bind(this)
  }

  textRenderFunction(seconds) {
    let mm;
    let ss;
    if (seconds == null || seconds <= 0) {
      return "00:00";
    }

    mm = (seconds / 60) | 0;
    ss = parseInt(seconds) - mm * 60;
    if (parseInt(mm) < 10) {
      mm = "0" + mm;
    }
    if (ss < 10) {
      ss = "0" + ss;
    }
    return mm + ":" + ss;
  }
  shengyi(){
    const {muted}=this.state
    this.setState({
      muted:!muted
    })
  }
  fnDown(e) {
    // console.log(1111111)
    this.X = e.clientX - this.cuttingRef.current.offsetLeft;
    console.log(document.touchmove)
    document.touchmove = this.fnMove.bind(this);
    document.touchend = this.fnUp.bind(this);
    const { videoRef } = this.state;
    if (videoRef && !videoRef.paused) {
      videoRef.pause();
    }
  }

  fnMove(e) {
    // console.log(2);
    let _this = this;
    let contentRef = this.contentRef.current.offsetWidth;
    let cuttingRef = this.cuttingRef.current.offsetWidth;
    this.disX = e.clientX - this.X;
    if (this.disX < 0) {
      this.setState({
        needX: 0,
      });
    } else if (this.disX > contentRef - cuttingRef) {
      this.disX = contentRef - cuttingRef;
    } else {
      this.setState({
        needX: _this.disX,
      });
    }
  }

  fnUp() {
    // 第三步：鼠标放开时document移除onmousemove事件
    // console.log(222222)
    document.touchmove = null;
    document.touchend = null;
    const { videoRef } = this.state;
    if (videoRef && videoRef.paused) {
      videoRef.play();
    }
  }

  time(value) {
    let _this = this;
    let arr = [];
    for (let i = 0; i < value; i++) {
      if (i % 5 === 0) {
        let time = _this.textRenderFunction(i);
        // let text = document.createTextNode(time);
        // let divCreate = document.createElement("div");
        // divCreate.appendChild(text);
        // _this.tickRef.current.appendChild(divCreate);
        arr.push(time);
      }
    }
    this.setState({
      arrOption: arr,
    });
  }

  widthToTime(width) {
    return width / this.state.unit;
  }

  timeToWidth(duration) {
    return duration * this.state.unit;
  }

  closeModel = () => {
    const { dispatch } = this.props;
    dispatch({
      type: "edit/save",
      payload: {
        isShowVideoClip: false,
      },
    });
  };

  getImageUrl = () => {
    const {
      editModel: { currentGroup, currentMaterialIndex, assetList },
    } = this.props;
    for (const key in currentGroup) {
      if (currentGroup.hasOwnProperty(key)) {
        let list = currentGroup[key],
          i = 0,
          len = list.length;
        for (; i < len; i++) {
          let material = list[i];
          if (material["key"] === currentMaterialIndex) {
            return {
              imageUrl: assetList[material["assetName"]],
              material: material,
            };
          }
        }
      }
    }

    return {
      imageUrl: "",
      material: {},
    };
  };

  handleOnOK = item => {
    const { dispatch } = this.props;

    dispatch({
      type: "editor/vediodata",
      payload: {
        type: "videoClip",
        data: {
          startTime: this.startTime,
          endTime: this.endTime,
        },
      },
    });

    this.closeModel();
  };

  onPressMove = (evt) => {
    // const {dispatch} = this.props;
    const {needX} = this.state;
    this.X =  evt.deltaX- this.cuttingRef.current.offsetLeft;
    // let _this = this;
    let contentRef = this.contentRef.current.offsetWidth;
    let cuttingRef = this.cuttingRef.current.offsetWidth;
    this.disX = evt.deltaX - this.X;
    if (this.disX < 0) {
      this.setState({
        needX: 0,
      });
    } else if (this.disX > contentRef - cuttingRef) {
      this.disX = contentRef - cuttingRef;
      if(evt.deltaX<0){
        this.setState({
          needX: needX+evt.deltaX,
        });
      }
    } else {
      this.setState({
        needX: needX+evt.deltaX,
      });
    }
    
    
  };

  goback = () => {
    window.history.back(-1);
  };
  next=()=>{
    const { dispatch ,editModel:{templateId}} = this.props;

    dispatch({
      type: "edit/vediodata",
      payload: {
        type: "videoClip",
        data: {
          startTime: this.startTime,
          endTime: this.endTime,
        },
      },
    });
    setTimeout(()=>{
      router.push({
        pathname: "/compile",
        query: {
          id:templateId,
          clip:templateId
        },
      });
    },500)
  }

  render() {
    const { needX, videoRef, totalTime, containerWidth,muted } = this.state,
      // { imageUrl, material } = this.getImageUrl(),
      {
        editModel: {
          videoupload,
          parseManage: { fps },
          // ratio
        },
      } = this.props,
      duration = videoupload.material["asset"]["ui"]["duration"] / fps,
      currentTime = this.widthToTime(needX);

    this.startTime = currentTime;
    this.endTime = currentTime + duration;

    let url = videoupload.url;
    if (videoupload.url.lastIndexOf("?") !== -1) {
      url = videoupload.url.substring(0, videoupload.url.lastIndexOf("?"));
    }

    if (videoRef) {
      videoRef.currentTime = currentTime;
      videoRef.addEventListener("canplay", () => {
        if (totalTime !== videoRef.duration) {
          let totalTime = videoRef.duration;
          this.setState({
            totalTime: totalTime,
            unit: containerWidth / totalTime,
          });
        }
        return false;
      });
    }

    return (
      <div
        // width={300}
        // visible={true}
        // title="视频裁切"
        // onCancel={this.closeModel}
        // onOk={() => this.handleOnOK(videoupload.material)}
      >
        <div className={styles.pagehead}>
          <Icon type="left" onClick={this.goback} />
        <span style={{ marginLeft: "30px" }}>VE</span>
        <Button onClick={this.next} type="link" style={{color:'#595959',fontWeight:'700',padding:'0 0'}}>下一步<Icon style={{color:'#595959',fontWeight:'700'}} type="right" /></Button>
      </div>
        <div className={styles.cutting}>
          <div className={`${styles.videoBox}`}>
            <video ref={ref => this.setState({ videoRef: ref })} src={url} muted={muted} controls autoplay='false'/>
          </div>
          {/* <div className={`${styles.timeBox}`}>
            {this.textRenderFunction(this.startTime)}-{this.textRenderFunction(this.endTime)}
          </div> */}
          <div className={styles.concrolBox}>
            <div className={`${styles.totalTimeBox}`}>{this.textRenderFunction(totalTime)}min</div>
            <Button shape="round" onClick={this.shengyi} ghost="false" type='primary' icon='audio'>静音</Button>
          </div>
          
          
          <div className={`flex ${styles.tick_content}`}>
            <div className={styles.video_frame} style={{ width: `${containerWidth}px` }}>
              <div
                className={styles.content_frame}
                ref={this.contentRef}
                style={{ width: `${containerWidth}px` }}
              >
                <AlloyFinger
                  onPressMove={evt => this.onPressMove(evt)}
                >
                <div
                  className={styles.cutting_frame}
                  ref={this.cuttingRef}
                  style={{
                    left: needX,
                    width: `${this.timeToWidth(duration)}px`,
                    maxWidth: `${containerWidth}px`,
                  }}
                  // onTouchStart={this.fnDown.bind(this)}
                >
                  <div className={styles.translateIcon} />
                  <div className={styles.cutting_region} />
                  <div className={styles.translateIcon} />
                </div>
                </AlloyFinger>
              </div>
            </div>
          </div>
        </div>
      </div>
    );
  }
}

const stateToProps = state => {
  return {
    editModel: state["edit"],
    // loading: state["loading"],
  };
};

export default connect(stateToProps)(VideoClip);
