import React, { PureComponent } from "react";
import { connect } from "dva";
import Upload from "utils/lib/Upload";
import Cropper from "utils/lib/Cropper";
import Affine from "utils/lib/Affine";
import ReplaceableJson from "utils/lib/ReplaceableJson";
import { getImage } from "utils";
import env from "@/env";
import Cookies from "js-cookie";
import styles from "./index.less";
// import router from "umi/router";
import EditMain from "components/EditMain";
import BotSar from "components/BotSar";
import FontColor from "components/FontColor";
import PageHead from "components/PageHead";
import { Button, Spin, message } from "antd";
let num = 0;
class Compile extends PureComponent {
  loadMore = e => {
    const { dispatch } = this.props;
    const newInnerHeight = window.innerHeight;
    // message.info(window.visualViewport.height)
    num++;
    if (num % 2 === 1) {
      dispatch({
        type: "edit/save",
        payload: {
          Listentoseehigh: {
            width: "100%",
          },
          keyboardStyle: 0,
        },
      });
    } else {
      dispatch({
        type: "edit/save",
        payload: {
          // Listentoseehigh: {
          //   position: "fixed",
          //   width: "100%",
          //   bottom: "30px",
          // },
          keyboardStyle: newInnerHeight,
        },
      });
    }
  };

  componentDidMount() {
    window.addEventListener("resize", this.loadMore);
    document.body.style.touchAction = "none";
    // console.log(document.body);
    /* touch-action:pan-y; */
  }

  componentWillUnmount() {
    window.removeEventListener("resize", this.loadMore);
    document.body.style.touchAction = "auto";
  }

  renderCompile = () => {
    const {
      editModel: {
        groupKeys,
        groups,
        ui_group,
        backgroundImageList,
        assetList,
        check,
        ratio,
        feg,
        guzhi,
      },
    } = this.props;
    if (groupKeys === null) {
      return;
    }
    const keysArray = Object.keys(groupKeys);
    const keyArrayList = keysArray.map(key => {
      let sty = {};
      if (feg === 0) {
        sty = {
          width: `${Number(ui_group[key - 1]["size"][0]) * ratio}px`,
          height: `${guzhi}px`,
        };
      } else {
        sty = {
          height: `${Number(ui_group[key - 1]["size"][1]) * ratio}px`,
          width: `${guzhi}px`,
        };
      }

      const editStyle = {
        ...sty,
        backgroundImage:
          String(backgroundImageList) !== "{}" || backgroundImageList.length > 0
            ? `url(${backgroundImageList[groups[key].backgroundImage]})`
            : "none",
        // height:'375px',
        // height: `${Number(ui_group[key - 1]["size"][1]) * ratio }px`,
        // width: "190px",
        // width: "180px",
        margin: "15px auto 0",
        border: "1px solid #e1e1e1",
        borderRadius: "3px",
        position: "relative",
        backgroundSize: "100%",
        overflow: "hidden",
      };
      return (
        <div
          key={key}
          style={editStyle}
          className={check === key ? `${styles.container}` : `${styles.hide}`}
        >
          <EditMain
            allMaterial={groups[key].allMaterial}
            indexMainKey={key + 1}
            scale={ratio}
            assetList={assetList}
            change={this.change}
            upfont={this.upfont}
            getfontcange={this.getfontcange}
            upPhoto={this.upPhoto}
          ></EditMain>
        </div>
      );
    });
    return keyArrayList;
  };

  renderBottomTab = () => {
    const {
      editModel: {
        groupKeys,
        groups,
        backgroundImageList,
        templateWidth,
        templateHeight,
        assetList,
        check,
        bili,
      },
    } = this.props;
    if (groupKeys === null) {
      return false;
    }
    const keysArray = Object.keys(groupKeys);
    const keyArrayList = keysArray.map(k => {
      const editStyle = {
        backgroundImage:
          String(backgroundImageList) !== "{}" || backgroundImageList.length > 0
            ? `url(${backgroundImageList[groups[k].backgroundImage]})`
            : "none",
        backgroundSize: "100%",
        overflow: "hidden",
        height: `${bili}px`, //
        width: `${templateWidth * (bili / templateHeight)}px`,
        // height: templateHeight * (bili / templateWidth), //
        // width: `${bili}px`,
      };
      return (
        <button
          className={k === check ? `${styles.redact} ${styles.bor_back}` : `${styles.redact}`}
          key={k}
          onClick={() => this.changeBottomTab(k)}
          style={editStyle}
        >
          <BotSar
            allMaterial={groups[k].allMaterial}
            scale={bili / Number(templateHeight)}
            assetList={assetList}
            indexkey={Number(k)}
          ></BotSar>
          <span className={k === check ? `${styles.amount} ${styles.bg_back}` : `${styles.amount}`}>
            {groupKeys[k].length}
          </span>
          <span
            // style={{ width: `${bili}px` }}
            style={{ width: "100%" }}
            className={k === check ? `${styles.reNumber} ${styles.bg_back}` : `${styles.reNumber}`}
          >
            编辑组{k}
          </span>
        </button>
      );
    });
    return keyArrayList;
  };

  changeBottomTab = k => {
    const { dispatch } = this.props;
    dispatch({
      type: "edit/changeBottomTab",
      payload: {
        check: k,
      },
    });
  };

  closecolorflag = () => {
    const {
      editModel: { color_flag },
      dispatch,
    } = this.props;
    if (color_flag) {
      dispatch({
        type: "edit/save",
        payload: {
          color_flag: false,
        },
      });
    }
  };
  dispatchMiddle = (type, payload) => {
    const { dispatch } = this.props;
    dispatch({
      type: `edit/${type}`,
      payload: payload,
    });
  };

  replacement = () => {
    const {
      editModel: { groups, check, allMaterialByGroup },
      dispatch,
    } = this.props;
    let arr = [];
    groups[check].allMaterial.map((item, k) => {
      if (item.type === 1) {
        arr.push(k);
      }
    });
    if (arr.length === 0) {
      message.warning("没有可重置的图片");
      return;
    }
    for (let k = 0; k < arr.length; k++) {
      const index = arr[k],
        data = allMaterialByGroup[check][index];
        let obj={}
        if(groups[check].allMaterial[index].initialPosition){
          let item=groups[check].allMaterial[index]
          obj = {
            ...groups[check].allMaterial[index],
            rotate: data.rotate,
            scale: [data.scale[0], data.scale[1]],
            position: [item.initialPosition[0], item.initialPosition[1]],
            distScale: [item.initialScale, item.initialScale],
            distRotate: data.rotate,
            recordSacle: item.initialScale,
          };
        }else{
          obj = {
            ...groups[check].allMaterial[index],
            rotate: data.rotate,
            scale: [data.scale[0], data.scale[1]],
            position: [data.position[0], data.position[1]],
            distScale: [1, 1],
            distRotate: data.rotate,
            recordSacle: 1,
          };
        }
        
      dispatch({
        type: "edit/onPressMove",
        payload: {
          obj: obj,
          index: index,
        },
      });
    }
  };

  batchupload = () => {
    const {
      editModel: { groups, check },
    } = this.props;
    let arr = [];
    groups[check].allMaterial.map(item => {
      if (item.type === 1) {
        arr.push(item.assetName);
      }
    });
    if (arr.length === 0) {
      // message.info(`没有可替换的个文件`);
      return;
    }
    // message.info(`最多可以${arr.length}个文件`);
    let batchupload = this.refs.batchupload;
    let ev = document.createEvent("MouseEvents");
      ev.initEvent("click", true, true);
      batchupload.dispatchEvent(ev);
    // setTimeout(()=>{
    //   let ev = document.createEvent("MouseEvents");
    //   ev.initEvent("click", true, true);
    //   batchupload.dispatchEvent(ev);
    // },400)
  };

  async upLoad(e) {
    const {
      editModel: { groups, check },
      dispatch,
    } = this.props;
    let file = e.target.files;
    let arr = [];
    let index = [];
    groups[check].allMaterial.map((item, k) => {
      if (item.type === 1) {
        arr.push(item.assetName);
        index.push(k);
      }
    });
    if (file.length === 0) {
      message.warning("没有选择文件");
      return;
    }
    if (file.length > arr.length) {
      message.warning(`最多可选择${arr.length}个文件`);
      return;
    }
    for (let i = 0; i < file.length; i++) {
      let file = e.target.files[i];
      let index = file.name.lastIndexOf(".");
      let ext = file.name.substr(index + 1).toLowerCase();
      if (ext !== "jpg" && ext !== "png" && ext !== "jpeg") {
        message.warning("请选择图片文件");
        return;
      }
    }
    dispatch({
      type: "edit/save",
      payload: {
        pageLoading: true,
      },
    });
    if (file.length < arr.length) {
      arr = arr.splice(0, file.length);
    }

    await arr.map((v, k) => {
      let url = this.batch_up(file[k], v, index[k]);
      return url;
    });
    this.refs.batchupload.value = "";
    dispatch({
      type: "edit/save",
      payload: {
        pageLoading: false,
      },
    });
  }

  async batch_up(data, v, index) {
    const {
      dispatch,
      editModel: { check, groups ,allMaterialByGroup},
    } = this.props;
    dispatch({
      type: "edit/save",
      payload: {
        pageLoading: true,
      },
    });
    const url = window.URL.createObjectURL(data);
    let reader = new FileReader();
    reader.readAsDataURL(data);
    reader.onload = function(e) {
      let image = new Image();
      image.src = e.target.result;
      image.onload = function() {
        let w = this.width;
        let h = this.height;
        let allGroup = allMaterialByGroup[check][index];
        let recordX 
        let recordY
        let initialScale 
        let obj={}
        if (h > allGroup["originSize"][1]+200 && w > allGroup["originSize"][0]+200) {
          initialScale = allGroup["originSize"][0] / w;
          recordX = -w *(1-initialScale)/2;
          recordY = -h *(1-initialScale)/2;
          obj = {
            ...groups[check].allMaterial[index],
            originSize: [w, h],
            anchor: [w / 2, h / 2],
            position:[recordX+allGroup.position[0],recordY+allGroup.position[1]],
            distScale:[initialScale,initialScale],
            recordSacle:initialScale,
            initialScale:initialScale,
            initialPosition:[recordX+allGroup.position[0],recordY+allGroup.position[1]]
          };
        }else{
          obj = {
            ...groups[check].allMaterial[index],
            originSize: [w, h],
            anchor: [w / 2, h / 2],
            position:[allGroup.position[0],allGroup.position[1]],
            distScale:[1,1],
            recordSacle:initialScale
          };
        }
        dispatch({
          type: "edit/handleTextChangeItem",
          payload: {
            obj: obj,
            index: index,
          },
        });
        dispatch({
          type: "edit/uploadPhoto",
          payload: {
            [v]: url,
          },
        });
      };
    };

    return url;
  }

  renderLoading(status, text) {
    if (!status) return null;
    return (
      <div className={`flex ${styles.loadingEditorContainer}`}>
        <Spin size="large" tip={`${text}...`} className={styles.spanpageloading} />
      </div>
    );
  }

  mapGroups(group) {
    let upload = new Upload({
      getTokenUrl: env.getTokenUrl,
      jwt: Cookies.get("__token__"),
      sourceHost: env.sourceHost,
    });

    const mapCb = async material => {
      let {
          type,
          assetName,
          originSize,
          isVideo,
          key,
          distRotate,
          distScale,
          distPosition,
          volume,
          videoClip,
        } = material,
        {
          editModel: { assetList, parseManage },
        } = this.props,
        currentUi = parseManage["uiAssets"][key]["ui"],
        editScale = currentUi["s"][0],
        materialWidth = currentUi["editSize"][0],
        materialHeight = currentUi["editSize"][1],
        originWidth = originSize[0],
        originHeight = originSize[1],
        isChangeMaterialSource = originWidth !== materialWidth && originHeight !== materialHeight,
        cropOptions = {
          width: materialWidth,
          height: materialHeight,
        },
        result = {
          key,
          type,
        };
      // console.log(distRotate, distPosition, distScale);
      if (type === 1) {
        let url = assetList[assetName],
          matrix = {
            anchor: {
              x: 0,
              y: 0,
            },
            position: {
              x: 0,
              y: 0,
            },
            zoom: {
              x: 1,
              y: 1,
            },
            rotation: 0,
          };

        if (distRotate || distScale || distPosition) {
          let centerX = materialWidth / 2,
            centerY = materialHeight / 2;

          matrix.anchor = {
            x: centerX,
            y: centerY,
          };
          matrix.position = {
            x: centerX,
            y: centerY,
          };

          if (distRotate) {
            matrix.rotation = distRotate;
          }

          if (distScale) {
            matrix.zoom.x = distScale[0];
            matrix.zoom.y = distScale[1];
          }

          if (distPosition) {
            matrix.position.x += distPosition[0];
            matrix.position.y += distPosition[1];
          }
        }

        if (isChangeMaterialSource) {
          matrix.anchor = {
            x: originWidth / 2,
            y: originHeight / 2,
          };
          if (!distPosition) {
            matrix.position.x = 0;
            matrix.position.y = 0;
            matrix.anchor = {
              x: 0,
              y: 0,
            };
          } else {
            matrix.position = {
              x: originWidth / 2 + distPosition[0],
              y: originHeight / 2 + distPosition[1],
            };
          }
        }
        if (isVideo) {
          result["imgUrl"] = url.substring(0, url.lastIndexOf("?"));
          result["isVideo"] = isVideo;
          result["adapt_type"] = 4;
          result["volume"] = volume;
          result["videoClip"] = videoClip;
          let videoMatrix = new Affine();
          videoMatrix.set(matrix.anchor, matrix.position, matrix.zoom, matrix.rotation);

          result["videoTransform"] = [
            videoMatrix.mA,
            videoMatrix.mC,
            videoMatrix.mE,
            videoMatrix.mB,
            videoMatrix.mD,
            videoMatrix.mF,
          ];

          return result;
        }

        let crop = new Cropper(cropOptions),
          img = await getImage(url);
        crop.setAffine(matrix);
        // console.log(img);
        await crop.drawImage(img, 0, 0, originWidth, originHeight);
        let bolbData = await crop.getBlobData(),
          fileData = new File([bolbData], assetName, { type: bolbData.type });
        result["imgUrl"] = await upload.uploadFile(fileData);

        console.log(result["imgUrl"]);
      }

      if (type === 2 || type === 3) {
        result["fontSetting"] = material["fontSetting"];
      }

      // throw new Error("-1");
      return result;
    };

    return Promise.all(group.map(mapCb));
  }

  async mapAllMaterialByGroup(allMaterialByGroup) {
    let key,
      currentGroup,
      resultJson = {};
    for (key in allMaterialByGroup) {
      if (allMaterialByGroup.hasOwnProperty(key)) {
        currentGroup = allMaterialByGroup[key];
        resultJson[key] = await this.mapGroups(currentGroup);
      }
    }

    return resultJson;
  }

  submitRendering = () => {
    const {
        editModel: { pageLoading, parseManage, currentTemplateInfo, groups, countFlagApply },
      } = this.props,
      { dispatchMiddle } = this;
    if (countFlagApply === 0) {
      message.warning("请替换素材");
      return;
    }
    if (pageLoading) return;
    let arr = Object.keys(groups);
    let allMaterialByGroup = {};
    arr.map((v, k) => {
      allMaterialByGroup[v] = groups[v].allMaterial;
      return allMaterialByGroup;
    });
    dispatchMiddle("save", {
      pageLoading: true,
      isShowCurrentTransform: false,
      currentMaterialIndex: -1,
      editWindowCurrentIndex: 1,
    });
    localStorage.setItem("PAGE_LOADING_TYPE", "1");

    this.mapAllMaterialByGroup(allMaterialByGroup).then(res => {
      dispatchMiddle("save", {
        pageLoading: false,
      });
      localStorage.setItem("PAGE_LOADING_TYPE", "0");
      console.log(res, parseManage.orderList, currentTemplateInfo);
      const replaceJson = new ReplaceableJson(res, parseManage.orderList, currentTemplateInfo.id),
        json = replaceJson.getJson();

      console.log(json);
      dispatchMiddle("submitRender", {
        json: json,
      });
    });
  };

  render() {
    const { renderCompile, renderBottomTab } = this;
    const {
      editModel: { color_flag, pageLoading, feg, Listentoseehigh },
    } = this.props;
    document.documentElement.addEventListener(
      "touchstart",
      function(event) {
        if (event.touches.length > 1) {
          event.preventDefault();
        }
      },
      { passive: false },
    );

    // document.addEventListener('touchmove', function (event) {
    //    window.event.returnValue = false;
    // }, false);
    // document.addEventListener('touchmove', function (event) {
    //  event.preventDefault();
    // }, false);
    // 禁止双击放大
    let lastTouchEnd = 0;
    document.documentElement.addEventListener(
      "touchend",
      function(event) {
        var now = Date.now();
        if (now - lastTouchEnd <= 300) {
          event.preventDefault();
        }
        lastTouchEnd = now;
      },
      { passive: false },
    );

    message.config({
      top: 100,
      duration: 1,
      maxCount: 1,
    });
    let photosty = {};
    if (feg === 1) {
      // sty={
      //   position: "fixed",
      //   width: "100%",
      //   bottom: "30px",
      // };
      photosty = {
        height: `${window.innerHeight * 0.55}px`,
        display: "flex",
        alignItems: "center",
      };
    }

    return (
      <div>
        <div onClick={this.closecolorflag}>
          <PageHead page="2"></PageHead>
          {/* height:'355px', */}
          <div style={photosty}>{renderCompile()}</div>
          <div className={styles.botsar} style={feg === 1 ? Listentoseehigh : null}>
            <div className={styles.upDiv}>
              <Button type="primary" shape="round" ghost="false" onClick={this.replacement}>
                重置
              </Button>
              <div>
                <input
                  ref="batchupload"
                  type="file"
                  accept="image/*"
                  multiple="multiple"
                  camera="true"
                  className={styles.upBtn}
                  onChange={e => this.upLoad(e)}
                />
                <Button
                  type="primary"
                  shape="round"
                  ghost="false"
                  icon="download"
                  onClick={this.batchupload}
                >
                  批量导入
                </Button>
              </div>
            </div>
            <div>
              <div className={styles.options}>{renderBottomTab()}</div>
            </div>
            <button
              className={styles.runmake}
              style={{ color: "#fff" }}
              onClick={this.submitRendering}
            >
              立即生成
            </button>
          </div>

          {this.renderLoading(pageLoading, "渲染中")}
        </div>
        {color_flag ? (
          <FontColor upfont={this.upfont} getfontcange={this.getfontcange}></FontColor>
        ) : null}
      </div>
    );
  }
}

const stateToProps = state => ({
  editModel: state["edit"],
});

export default connect(stateToProps)(Compile);
