import React, { PureComponent } from "react";
import { connect } from "dva";
import styles from "./index.less";
import router from "umi/router";
import PageHead from "components/PageHead";
// import { Pagination } from "antd";
import { Tabs ,message} from "antd";
// import { Tabs ,WhiteSpace} from 'antd-mobile';
// import 'antd-mobile/dist/antd-mobile.css';

let wid = {};
let imgwid = {};
let iTime;
class List extends PureComponent {
  state = {
    startX: 0,
    startY: 0,
  };

  loadMore = e => {
    const {listModel:{template_group,current_page,total,tagList, tabindex},dispatch}= this.props
    const {startY}= this.state
    let newstartY = e.touches[0].screenY
    if(startY-newstartY>100){
      if(current_page<=total/10){
        clearTimeout(iTime);
        iTime = setTimeout(function () {
          dispatch({
            type:'list/pagelistpushdata',
            payload:{
              template_group: tagList[tabindex].category_id,
              category_id: tagList[tabindex].category_id,
              page: current_page+1,
              page_size: 10,
            }
          })
        }, 200);
      }else{
        // message.info('没有更多了')
      }
    }
  };

  loadStart = e =>{
    let startY = e.touches[0].screenY
    this.setState({
      startY:startY
    })
    // console.log(e);
  }

  componentDidMount() {
    window.addEventListener("touchmove", this.loadMore);
    window.addEventListener("touchstart", this.loadStart);
  }

  componentWillUnmount() {
    window.removeEventListener("touchmove", this.loadMore);
    window.removeEventListener("touchstart", this.loadStart);
  }

  renderTemplateList = () => {
    const {
      listModel: { list },
    } = this.props;
    const List = list.map((v, k) => {
      return (
        <div key={v.id} style={{ width: "50%", display: "flex", justifyContent: "center" }}>
          <div style={wid} className={styles.boxli}>
            <div className={styles.qw} style={imgwid} data-tpl-id={v.id}>
              <div className={styles.div1}>
                {v.template_cover_image ? (
                  <img src={v.template_cover_image} alt="" />
                ) : (
                  <div style={{ width: "100%" }} className={styles.tihuanimg}>
                    暂无封面
                  </div>
                )}
              </div>
              <div className={styles.btnMake} onClick={() => this.handleButtonClick(v.id)}>立即制作</div>
            </div>
            <div className={styles.generalize}>
              <span className={styles.telName}>{v.template_name}</span>
              <span className={styles.heat}>{v.tag || '热门'}</span>
            </div>
          </div>
        </div>
      );
    });
    const falg = list.length > 0;
    return (
      <div
        onScroll={this.listscrool}
        ref="ul"
        id="ul"
        className={`${styles.max} ${falg ? null : styles.addheight}`}
      >
        {List}
      </div>
    );
  };
  listscrool =(e)=>{
    console.log(1)
  }
  renderTab = () => {
    const {
      listModel: { tagList, tabindex },
    } = this.props;
    const foussty = {
      borderBottom: "2px solid #1890ff",
      color: "#000000",
      fontSize: "14px",
    };
    const List = tagList.map((v, k) => {
      return (
        <li
          key={v.category_id}
          className={styles.myli}
          // style={tabindex === k ? foussty : null}
          onClick={() => this.onTabLicilik(v, k)}
        >
          <div style={tabindex === k ? foussty : null}>{v.category_name}</div>
        </li>
      );
    });
    return <ul className={styles.myul}>{List}</ul>;
  };

  onTabLicilik = (template_group, k) => {
    const { dispatch } = this.props;
    dispatch({
      type: "list/getTemplateList",
      payload: {
        template_group: template_group.category_id,
        category_id: template_group.category_id,
        page: 1,
        page_size:10,
      },
    });
    dispatch({
      type: "list/save",
      payload: {
        tabindex: k,
      },
    });
  };

  handleButtonClick = id => {
    router.push({
      pathname: "/edit",
      query: {
        templateId: id,
      },
    });
  };
  render() {
    const { renderTemplateList, renderTab } = this;
    message.config({
      top: 100,
      duration: 1,
      maxCount: 1,
    });
    if (window.innerWidth === 320) {
      wid = {
        width: "140px",
        // margin:'0 6px 10px 6px'
      };
      imgwid = {
        width: "140px",
        height: "200px",
      };
    }
    if (window.innerWidth > 375) {
      wid = {
        width: "170px",
        // margin:'0 10px 10px 15px'
      };
      imgwid = {
        width: "170px",
      };
    }

    return (
      <div className={styles.container}>
        <PageHead page="1"></PageHead>
        {renderTab()}
        {renderTemplateList()}
      </div>
    );
  }
}

const stateToProps = state => ({
  listModel: state["list"],
});

export default connect(stateToProps)(List);
