import React, { useEffect, useState } from "react";
import { connect } from "dva";
import styles from "./index.less";
import axios from "axios";
import env from "@/env";
import router from "umi/router";
// import PageHead from "components/PageHead";
import { Button, Icon } from "antd";

function VideoPlay(props) {
  const [loading, setLoading] = useState(true),
    [url, setUrl] = useState(""),
    { orderId, recordId ,videoUrl} = props.location.state;
    console.log(props.location.state);

  useEffect(() => {
    let timerId = -1;
    const pollVideoIsLoadSuccess = id => {
      return new Promise(resolve => {
        timerId = setInterval(async () => {
          const { data } = await axios({
            // url: `${env.host}/demo/public/get_status`,
            url: `${env.host}/TemplateDemo.php?act=get_status&record_id=${id}`,
            method: "get",
            data: {
              record_id: id,
              act:"get_status",
            },
          });

          if (data.errno !== 0) {
            clearInterval(timerId);
          }

          if (data.data.status == 1) {
            clearInterval(timerId);
            resolve(`${env.sourceHost}${videoUrl}`);
          }
        }, 500);
      });
    };
    pollVideoIsLoadSuccess(recordId).then(url => {
      setLoading(false);
      setUrl(url);
    });

    return () => {
      clearInterval(timerId);
    };
  }, [recordId, videoUrl]);

  const goback = () => {
    window.history.back(-1);
  };
  const next = () => {
    router.push({
      pathname: "/",
    });
  };
  const {feg} = props.edit
  let sty ={
    outline: "none" ,
    maxWidth:'100%'
  }
  if(feg===0){
    sty={
      outline: "none" ,
      maxWidth:'100%',
      height:'100%'
    }
  }
  return loading ? (
    <div>
      <div className={styles.pagehead}>
        <Icon type="left" onClick={goback} />
        <span style={{ marginLeft: "-15px" }}>VE</span>
        <Button
          onClick={next}
          type="link"
          style={{ color: "#595959", fontWeight: "700", padding: "0 0" }}
        >
          {/* 首页
          <Icon style={{ color: "#595959", fontWeight: "700" }} type="right" /> */}
        </Button>
      </div>
      <div className={styles.content}>
        <div className={styles.loadingBox}>
          <div className={`flex ${styles.loaderContainer}`}>
            <div className={`${styles.eight}`} />
          </div>
        </div>
        <p>渲染中...</p>
      </div>
    </div>
  ) : (
    <div>
      <div className={styles.pagehead}>
        <Icon type="left" onClick={goback} />
        <span style={{ marginLeft: "-15px" }}>VE</span>
        <Button
          onClick={next}
          type="link"
          style={{ color: "#595959", fontWeight: "700", padding: "0 0" }}
        >
          {/* 首页
          <Icon style={{ color: "#595959", fontWeight: "700" }} type="right" /> */}
        </Button>
      </div>
      <div className={styles.videoPlay}>
        <div style={{ height: "75vh",width:'100%',display:'flex',justifyContent: 'center',alignItems:'center'}}>
        <video
          src={url}
          playsInline={true}
          style={sty}
          webkit-playsinline="true"
          controls
          autoPlay="autoplay"
        ></video>
        </div>
      </div>
      <div className={styles.btn_div}>
        <button className={styles.runmake} style={{ color: "#fff" }} onClick={next}>
          返回首页
        </button>
      </div>
    </div>
  );
}

const stateToProps = state => {
  return {
    edit: state["edit"],
    // loading: state["loading"],
  };
};

export default connect(stateToProps)(VideoPlay);
